; $Id: 4220uart.inc,v 1.1 2005/02/01 19:08:35 tgipson Exp $
str_uart_ver:
;	DW	"$Id: 4220uart.inc,v 1.1 2005/02/01 19:08:35 tgipson Exp $\r\n\x00"


; Drop-in SPI routines for PIC18F4220



INITUSART:

	BCF	RCSTA,SPEN	; Serial port disable
	BCF	RCSTA,SREN	; Disable single reception
	BCF	RCSTA,CREN	; Disable continious reception


	bsf		TRISC, 7	; RC7 input (Rx)
	bcf		TRISC, 6	; RC6 (Tx)

;	MOVLB	BANK4		; Select register bank 4

;	MOVLW	D'12'		; (40 MHz?) 8MHz clock, 9600 baud, BRGH low-speed
;	movlw	D'77'
	movlw	D'01'
	movwf	SPBRGH
	movlw	D'56'
	movwf	SPBRG

	bsf		BAUDCON, BRG16


	;MOVWF	SPBRG		; Initialise baud rate generator
;	movff	BAUD, SPBRG	; Initialize baud rate generator with already-defined rate

	bcf		TXSTA, BRGH						; disable hi-speed baud clock
	;bsf		TXSTA, BRGH						; Enable hi-speed baud clock
	BSF	TXSTA,CSRC	; Master mode, clk from BRG
	BCF	TXSTA,TX9	; Select 8 bit tansmission
	BCF	TXSTA,TXEN	; Transmission disabled
	BCF	TXSTA,SYNC	; Asynchronous mode

	BCF	RCSTA,RX9	; Select 8 bit reception

	BSF	RCSTA,SPEN	; Serial port enable
	BSF	TXSTA,TXEN	; Enable transmission
	;BCF	PIE1,RC1IE
	BSF	RCSTA,CREN	; Enable reception


	return

; ---------------------------------------------
SENDCMNDP2:
SENDCMD:			; Send Wreg contents to USART

	BTFSS	TXSTA,TRMT	; Wait until transmitter ready to send next byte
	GOTO	SENDCMD
	MOVWF	TXREG		; Transfer next byte from WREG to 
                        ; transmitter register
	RETURN


SENDCMNDP2CR:
	movlw	'\r'
	call	SENDCMD
	movlw	'\n'
	call	SENDCMD
	return

; ---------------------------------------------
GETCMD:
	btfss	PIR1, RCIF					; byte received on USART?
	goto	GETCMD						; if no
	movf	RCREG,0						; if yes - to W
	;movwf	BYTE						; store it here
	return

